//all liaberies
#include <Servo.h>


//Constant vars
//all pins
int on_switch_pin = 2;
int turn_left_pin = 3;
int turn_right_pin = 4;
int light_pin = 7;
int servo_pin = 8;
//miscellaneous
int button_delay = 500;
Servo servo_motor;


//dynamic vars
//button states
int on_switch_buttonState = 0;
int turn_left_buttonState = 0;
int turn_right_buttonState = 0;
//miscellaneous
int is_on = 0;
int current_rot_servo = 0;



void setup() 
{
  set_pinmodi(); //set all pin modi
  servo_motor.write(0); //to calibrate servo
}

void loop() 
{
  //check all buttons
  check_on_button_state();
  check_left_turn_button();
  check_right_turn_button(); 
}
//set all pin modi
void set_pinmodi()
{
  pinMode(light_pin, OUTPUT);
  pinMode(on_switch_pin, INPUT);
  pinMode(turn_left_pin, INPUT);
  pinMode(turn_right_pin, INPUT);
  pinMode(servo_pin, OUTPUT);
  servo_motor.attach(servo_pin);
}

void check_on_button_state()
{
  on_switch_buttonState = digitalRead(on_switch_pin); //update if button is pressed
  if (is_on == 0 && on_switch_buttonState == HIGH) //check if button is pressed (on_switch_buttonState) & if device is already powerd on (is_on, 0 = off and 1 = on)
    {
      digitalWrite(light_pin, HIGH); //switch light on
      servo_motor.write(90); //turn servo motor
      current_rot_servo = 90; //keep track of current rotation
      delay(button_delay); //to give user time to release button
      is_on = 1; //keep track of device is turned on
    }
  on_switch_buttonState = digitalRead(on_switch_pin); //update if button is pressed
  if (is_on == 1 && on_switch_buttonState == HIGH) //check if button is pressed (on_switch_buttonState) & if device is already powerd on (is_on, 0 = off and 1 = on)
    {
      digitalWrite(light_pin, LOW); //switch light off
      servo_motor.write(0); //turn servo motor
      current_rot_servo = 0; //keep track of current rotation
      delay(button_delay); //to give user time to release button
      is_on = 0; //keep track of device is turned on
    }
}

void check_left_turn_button()
{
  turn_left_buttonState = digitalRead(turn_left_pin); //update if button is pressed
  if (turn_left_buttonState == HIGH) //check if button is pressed
    {
      current_rot_servo -= 10; //calculate new rotation
      if (current_rot_servo <= 0) //check if it doesn't cross boundery
        {
          current_rot_servo = 0; //boundery crossed, go to minimum value
          servo_motor.write(0); //turn servo to minimum value
          delay(button_delay); //to give user time to release button
        }
      else
        {
          servo_motor.write(current_rot_servo); //turn servo to new rotation
          delay(button_delay); //to give user time to release button
        }
    }
}

void check_right_turn_button()
{
  turn_right_buttonState = digitalRead(turn_right_pin); //update if button is pressed
  if (turn_right_buttonState == HIGH) //check if button is pressed
    {
      current_rot_servo += 10; //calculate new rotation
      if (current_rot_servo >= 180) //check if it doesn't cross boundery
        {
          current_rot_servo = 180; //boundery crossed, go to minimum value
          servo_motor.write(180); //turn servo to maximum value
          delay(button_delay); //to give user time to release button
        }
      else
        {
          servo_motor.write(current_rot_servo); //turn servo to new rotation
          delay(button_delay); //to give user time to release button
        }
    }
}



//all test functions
void test_servo()
{
  servo_motor.write(90);
  delay(1000);
  servo_motor.write(0);
  delay(1000);
  
}

void test_check_on_button_state()
{
  on_switch_buttonState = digitalRead(on_switch_pin);

  
  if (on_switch_buttonState == HIGH) 
  {
    digitalWrite(light_pin, HIGH); 
    Serial.println('Y');
  } else {
    digitalWrite(light_pin, LOW);
    Serial.println('N');
  }
}

void test_light()
{
  digitalWrite(light_pin, HIGH);  
  delay(1000);                     
  digitalWrite(light_pin, LOW);   
  delay(1000); 
}